import argparse

from clifinance.application.abstractions.protocols.gateway import DataGateway
from clifinance.application.dto.expense import ExpenseDTO, ExpenseTypeDTO


class AddExpense:
    def __init__(
        self,
        gateway: DataGateway,
    ) -> None:
        self.__gateway = gateway

    def __call__(self, args: argparse.Namespace) -> None:
        self.__gateway.add_expense(
            exp=ExpenseDTO(
                id=None,
                type=(ExpenseTypeDTO.INCOME if args.type == "income" else ExpenseTypeDTO.EXPENSE),
                date=args.date,
                amount=args.amount,
                description=args.description,
            )
        )
