import argparse

from clifinance.main.container import Container


def get_balance(args: argparse.Namespace, ioc: Container) -> None:
    with ioc.provide_get_balance() as usecase:
        print(usecase())


def select_expenses(args: argparse.Namespace, ioc: Container) -> None:
    print(args)


def add_expense(args: argparse.Namespace, ioc: Container) -> None:
    if not all(args.__dict__.values()):
        raise argparse.ArgumentError(
            argument=None,
            message="All arguments are required: -t, -d, -a, -D",
        )
    if args.type == "income" and args.amount < 0:
        raise argparse.ArgumentError(argument=None, message="An income cannot have a negative amount.")
    if args.type == "expense" and args.amount > 0:
        raise argparse.ArgumentError(argument=None, message="An expense cannot have a positive amount.")

    with ioc.provide_add_expense() as usecase:
        usecase(args=args)
